## wpa 2.1

=== hostapd/Makefile ===
ifndef CC
CC=gcc
endif

ifndef CFLAGS
CFLAGS = -MMD -O2 -Wall -g
endif

CFLAGS += -I$(abspath ../src)
CFLAGS += -I$(abspath ../src/utils)

# Uncomment following line and set the path to your kernel tree include
# directory if your C library does not include all header files.
# CFLAGS += -DUSE_KERNEL_HEADERS -I/usr/src/linux/include

-include .config

ifdef CONFIG_TESTING_OPTIONS
CFLAGS += -DCONFIG_TESTING_OPTIONS
CONFIG_WPS_TESTING=y
endif

ifndef CONFIG_OS
ifdef CONFIG_NATIVE_WINDOWS
CONFIG_OS=win32
else
CONFIG_OS=unix
endif
endif

ifeq ($(CONFIG_OS), internal)
CFLAGS += -DOS_NO_C_LIB_DEFINES
endif

ifdef CONFIG_NATIVE_WINDOWS
CFLAGS += -DCONFIG_NATIVE_WINDOWS
LIBS += -lws2_32
endif

OBJS += main.o
OBJS += config_file.o

OBJS += ../src/ap/hostapd.o
OBJS += ../src/ap/wpa_auth_glue.o
OBJS += ../src/ap/drv_callbacks.o
OBJS += ../src/ap/ap_drv_ops.o
OBJS += ../src/ap/utils.o
OBJS += ../src/ap/authsrv.o
OBJS += ../src/ap/ieee802_1x.o
OBJS += ../src/ap/ap_config.o
OBJS += ../src/ap/eap_user_db.o
OBJS += ../src/ap/ieee802_11_auth.o
OBJS += ../src/ap/sta_info.o
OBJS += ../src/ap/wpa_auth.o
OBJS += ../src/ap/tkip_countermeasures.o
OBJS += ../src/ap/ap_mlme.o
OBJS += ../src/ap/wpa_auth_ie.o
OBJS += ../src/ap/preauth_auth.o
OBJS += ../src/ap/pmksa_cache_auth.o
OBJS += ../src/ap/ieee802_11_shared.o
OBJS += ../src/ap/beacon.o

OBJS_c = hostapd_cli.o ../src/common/wpa_ctrl.o ../src/utils/os_$(CONFIG_OS).o

NEED_RC4=y
NEED_AES=y
NEED_MD5=y
NEED_SHA1=y

OBJS += ../src/drivers/drivers.o
CFLAGS += -DHOSTAPD

ifdef CONFIG_WPA_TRACE
CFLAGS += -DWPA_TRACE
OBJS += ../src/utils/trace.o
HOBJS += ../src/utils/trace.o
LDFLAGS += -rdynamic
CFLAGS += -funwind-tables
ifdef CONFIG_WPA_TRACE_BFD
CFLAGS += -DWPA_TRACE_BFD
LIBS += -lbfd
LIBS_c += -lbfd
LIBS_h += -lbfd
endif
endif

ifndef CONFIG_ELOOP
CONFIG_ELOOP=eloop
endif
OBJS += ../src/utils/$(CONFIG_ELOOP).o
OBJS_c += ../src/utils/$(CONFIG_ELOOP).o

ifeq ($(CONFIG_ELOOP), eloop)
# Using glibc < 2.17 requires -lrt for clock_gettime()
LIBS += -lrt
LIBS_c += -lrt
LIBS_h += -lrt
endif

OBJS += ../src/utils/common.o
OBJS += ../src/utils/wpa_debug.o
OBJS_c += ../src/utils/wpa_debug.o
OBJS += ../src/utils/wpabuf.o
OBJS += ../src/utils/os_$(CONFIG_OS).o
OBJS += ../src/utils/ip_addr.o

OBJS += ../src/common/ieee802_11_common.o
OBJS += ../src/common/wpa_common.o

OBJS += ../src/eapol_auth/eapol_auth_sm.o


ifdef CONFIG_CODE_COVERAGE
CFLAGS += -O0 -fprofile-arcs -ftest-coverage
LIBS += -lgcov
LIBS_c += -lgcov
LIBS_h += -lgcov
LIBS_n += -lgcov
endif

ifndef CONFIG_NO_DUMP_STATE
# define HOSTAPD_DUMP_STATE to include support for dumping internal state
# through control interface commands (undefine it, if you want to save in
# binary size)
CFLAGS += -DHOSTAPD_DUMP_STATE
OBJS += ../src/eapol_auth/eapol_auth_dump.o
endif

ifdef CONFIG_NO_RADIUS
CFLAGS += -DCONFIG_NO_RADIUS
CONFIG_NO_ACCOUNTING=y
else
OBJS += ../src/radius/radius.o
OBJS += ../src/radius/radius_client.o
OBJS += ../src/radius/radius_das.o
endif

ifdef CONFIG_NO_ACCOUNTING
CFLAGS += -DCONFIG_NO_ACCOUNTING
else
OBJS += ../src/ap/accounting.o
endif

ifdef CONFIG_NO_VLAN
CFLAGS += -DCONFIG_NO_VLAN
else
OBJS += ../src/ap/vlan_init.o
ifdef CONFIG_VLAN_NETLINK
ifdef CONFIG_FULL_DYNAMIC_VLAN
OBJS += ../src/ap/vlan_util.o
endif
CFLAGS += -DCONFIG_VLAN_NETLINK
endif
endif

ifdef CONFIG_NO_CTRL_IFACE
CFLAGS += -DCONFIG_NO_CTRL_IFACE
else
OBJS += ctrl_iface.o
OBJS += ../src/ap/ctrl_iface_ap.o
endif

OBJS += ../src/crypto/md5.o

CFLAGS += -DCONFIG_CTRL_IFACE -DCONFIG_CTRL_IFACE_UNIX

ifdef CONFIG_IAPP
CFLAGS += -DCONFIG_IAPP
OBJS += ../src/ap/iapp.o
endif

ifdef CONFIG_RSN_PREAUTH
CFLAGS += -DCONFIG_RSN_PREAUTH
CONFIG_L2_PACKET=y
endif

ifdef CONFIG_PEERKEY
CFLAGS += -DCONFIG_PEERKEY
OBJS += ../src/ap/peerkey_auth.o
endif

ifdef CONFIG_IEEE80211W
CFLAGS += -DCONFIG_IEEE80211W
NEED_SHA256=y
NEED_AES_OMAC1=y
endif

ifdef CONFIG_IEEE80211R
CFLAGS += -DCONFIG_IEEE80211R
OBJS += ../src/ap/wpa_auth_ft.o
NEED_SHA256=y
NEED_AES_OMAC1=y
NEED_AES_UNWRAP=y
endif

ifdef CONFIG_SAE
CFLAGS += -DCONFIG_SAE
OBJS += ../src/common/sae.o
NEED_ECC=y
NEED_DH_GROUPS=y
endif

ifdef CONFIG_WNM
CFLAGS += -DCONFIG_WNM
OBJS += ../src/ap/wnm_ap.o
endif

ifdef CONFIG_IEEE80211N
CFLAGS += -DCONFIG_IEEE80211N
endif

ifdef CONFIG_IEEE80211AC
CFLAGS += -DCONFIG_IEEE80211AC
endif

include ../src/drivers/drivers.mak
OBJS += $(DRV_AP_OBJS)
CFLAGS += $(DRV_AP_CFLAGS)
LDFLAGS += $(DRV_AP_LDFLAGS)
LIBS += $(DRV_AP_LIBS)

ifdef CONFIG_L2_PACKET
ifdef CONFIG_DNET_PCAP
ifdef CONFIG_L2_FREEBSD
LIBS += -lpcap
OBJS += ../src/l2_packet/l2_packet_freebsd.o
else
LIBS += -ldnet -lpcap
OBJS += ../src/l2_packet/l2_packet_pcap.o
endif
else
OBJS += ../src/l2_packet/l2_packet_linux.o
endif
else
OBJS += ../src/l2_packet/l2_packet_none.o
endif


ifdef CONFIG_EAP_MD5
CFLAGS += -DEAP_SERVER_MD5
OBJS += ../src/eap_server/eap_server_md5.o
CHAP=y
endif

ifdef CONFIG_EAP_TLS
CFLAGS += -DEAP_SERVER_TLS
OBJS += ../src/eap_server/eap_server_tls.o
TLS_FUNCS=y
endif

ifdef CONFIG_EAP_UNAUTH_TLS
CFLAGS += -DEAP_SERVER_UNAUTH_TLS
ifndef CONFIG_EAP_TLS
OBJS += ../src/eap_server/eap_server_tls.o
TLS_FUNCS=y
endif
endif

ifdef CONFIG_EAP_PEAP
CFLAGS += -DEAP_SERVER_PEAP
OBJS += ../src/eap_server/eap_server_peap.o
OBJS += ../src/eap_common/eap_peap_common.o
TLS_FUNCS=y
CONFIG_EAP_MSCHAPV2=y
endif

ifdef CONFIG_EAP_TTLS
CFLAGS += -DEAP_SERVER_TTLS
OBJS += ../src/eap_server/eap_server_ttls.o
TLS_FUNCS=y
CHAP=y
endif

ifdef CONFIG_EAP_MSCHAPV2
CFLAGS += -DEAP_SERVER_MSCHAPV2
OBJS += ../src/eap_server/eap_server_mschapv2.o
MS_FUNCS=y
endif

ifdef CONFIG_EAP_GTC
CFLAGS += -DEAP_SERVER_GTC
OBJS += ../src/eap_server/eap_server_gtc.o
endif

ifdef CONFIG_EAP_SIM
CFLAGS += -DEAP_SERVER_SIM
OBJS += ../src/eap_server/eap_server_sim.o
CONFIG_EAP_SIM_COMMON=y
NEED_AES_CBC=y
endif

ifdef CONFIG_EAP_AKA
CFLAGS += -DEAP_SERVER_AKA
OBJS += ../src/eap_server/eap_server_aka.o
CONFIG_EAP_SIM_COMMON=y
NEED_SHA256=y
NEED_AES_CBC=y
endif

ifdef CONFIG_EAP_AKA_PRIME
CFLAGS += -DEAP_SERVER_AKA_PRIME
endif

ifdef CONFIG_EAP_SIM_COMMON
OBJS += ../src/eap_common/eap_sim_common.o
# Example EAP-SIM/AKA interface for GSM/UMTS authentication. This can be
# replaced with another file implementating the interface specified in
# eap_sim_db.h.
OBJS += ../src/eap_server/eap_sim_db.o
NEED_FIPS186_2_PRF=y
endif

ifdef CONFIG_EAP_PAX
CFLAGS += -DEAP_SERVER_PAX
OBJS += ../src/eap_server/eap_server_pax.o ../src/eap_common/eap_pax_common.o
endif

ifdef CONFIG_EAP_PSK
CFLAGS += -DEAP_SERVER_PSK
OBJS += ../src/eap_server/eap_server_psk.o ../src/eap_common/eap_psk_common.o
NEED_AES_OMAC1=y
NEED_AES_ENCBLOCK=y
NEED_AES_EAX=y
endif

ifdef CONFIG_EAP_SAKE
CFLAGS += -DEAP_SERVER_SAKE
OBJS += ../src/eap_server/eap_server_sake.o ../src/eap_common/eap_sake_common.o
endif

ifdef CONFIG_EAP_GPSK
CFLAGS += -DEAP_SERVER_GPSK
OBJS += ../src/eap_server/eap_server_gpsk.o ../src/eap_common/eap_gpsk_common.o
ifdef CONFIG_EAP_GPSK_SHA256
CFLAGS += -DEAP_GPSK_SHA256
endif
NEED_SHA256=y
NEED_AES_OMAC1=y
endif

ifdef CONFIG_EAP_PWD
CFLAGS += -DEAP_SERVER_PWD
OBJS += ../src/eap_server/eap_server_pwd.o ../src/eap_common/eap_pwd_common.o
NEED_SHA256=y
endif

ifdef CONFIG_EAP_EKE
CFLAGS += -DEAP_SERVER_EKE
OBJS += ../src/eap_server/eap_server_eke.o ../src/eap_common/eap_eke_common.o
NEED_DH_GROUPS=y
NEED_DH_GROUPS_ALL=y
endif

ifdef CONFIG_EAP_VENDOR_TEST
CFLAGS += -DEAP_SERVER_VENDOR_TEST
OBJS += ../src/eap_server/eap_server_vendor_test.o
endif

ifdef CONFIG_EAP_FAST
CFLAGS += -DEAP_SERVER_FAST
OBJS += ../src/eap_server/eap_server_fast.o
OBJS += ../src/eap_common/eap_fast_common.o
TLS_FUNCS=y
NEED_T_PRF=y
NEED_AES_UNWRAP=y
endif

ifdef CONFIG_WPS
ifdef CONFIG_WPS2
CFLAGS += -DCONFIG_WPS2
endif

CFLAGS += -DCONFIG_WPS -DEAP_SERVER_WSC
OBJS += ../src/utils/uuid.o
OBJS += ../src/ap/wps_hostapd.o
OBJS += ../src/eap_server/eap_server_wsc.o ../src/eap_common/eap_wsc_common.o
OBJS += ../src/wps/wps.o
OBJS += ../src/wps/wps_common.o
OBJS += ../src/wps/wps_attr_parse.o
OBJS += ../src/wps/wps_attr_build.o
OBJS += ../src/wps/wps_attr_process.o
OBJS += ../src/wps/wps_dev_attr.o
OBJS += ../src/wps/wps_enrollee.o
OBJS += ../src/wps/wps_registrar.o
NEED_DH_GROUPS=y
NEED_SHA256=y
NEED_BASE64=y
NEED_AES_CBC=y
NEED_MODEXP=y
CONFIG_EAP=y

ifdef CONFIG_WPS_NFC
CFLAGS += -DCONFIG_WPS_NFC
OBJS += ../src/wps/ndef.o
NEED_WPS_OOB=y
endif

ifdef NEED_WPS_OOB
CFLAGS += -DCONFIG_WPS_OOB
endif

ifdef CONFIG_WPS_UPNP
CFLAGS += -DCONFIG_WPS_UPNP
OBJS += ../src/wps/wps_upnp.o
OBJS += ../src/wps/wps_upnp_ssdp.o
OBJS += ../src/wps/wps_upnp_web.o
OBJS += ../src/wps/wps_upnp_event.o
OBJS += ../src/wps/wps_upnp_ap.o
OBJS += ../src/wps/upnp_xml.o
OBJS += ../src/wps/httpread.o
OBJS += ../src/wps/http_client.o
OBJS += ../src/wps/http_server.o
endif

ifdef CONFIG_WPS_STRICT
CFLAGS += -DCONFIG_WPS_STRICT
OBJS += ../src/wps/wps_validate.o
endif

ifdef CONFIG_WPS_TESTING
CFLAGS += -DCONFIG_WPS_TESTING
endif

endif

ifdef CONFIG_EAP_IKEV2
CFLAGS += -DEAP_SERVER_IKEV2
OBJS += ../src/eap_server/eap_server_ikev2.o ../src/eap_server/ikev2.o
OBJS += ../src/eap_common/eap_ikev2_common.o ../src/eap_common/ikev2_common.o
NEED_DH_GROUPS=y
NEED_DH_GROUPS_ALL=y
NEED_MODEXP=y
NEED_CIPHER=y
endif

ifdef CONFIG_EAP_TNC
CFLAGS += -DEAP_SERVER_TNC
OBJS += ../src/eap_server/eap_server_tnc.o
OBJS += ../src/eap_server/tncs.o
NEED_BASE64=y
ifndef CONFIG_DRIVER_BSD
LIBS += -ldl
endif
endif

# Basic EAP functionality is needed for EAPOL
OBJS += eap_register.o
OBJS += ../src/eap_server/eap_server.o
OBJS += ../src/eap_common/eap_common.o
OBJS += ../src/eap_server/eap_server_methods.o
OBJS += ../src/eap_server/eap_server_identity.o
CFLAGS += -DEAP_SERVER_IDENTITY

ifdef CONFIG_EAP
CFLAGS += -DEAP_SERVER
endif

ifdef CONFIG_PKCS12
CFLAGS += -DPKCS12_FUNCS
endif

ifdef MS_FUNCS
OBJS += ../src/crypto/ms_funcs.o
NEED_DES=y
NEED_MD4=y
endif

ifdef CHAP
OBJS += ../src/eap_common/chap.o
endif

ifdef TLS_FUNCS
NEED_DES=y
# Shared TLS functions (needed for EAP_TLS, EAP_PEAP, and EAP_TTLS)
CFLAGS += -DEAP_TLS_FUNCS
OBJS += ../src/eap_server/eap_server_tls_common.o
NEED_TLS_PRF=y
endif

ifndef CONFIG_TLS
CONFIG_TLS=openssl
endif

ifdef CONFIG_TLSV11
CFLAGS += -DCONFIG_TLSV11
endif

ifdef CONFIG_TLSV12
CFLAGS += -DCONFIG_TLSV12
NEED_SHA256=y
endif

ifeq ($(CONFIG_TLS), openssl)
ifdef TLS_FUNCS
OBJS += ../src/crypto/tls_openssl.o
LIBS += -lssl
endif
OBJS += ../src/crypto/crypto_openssl.o
HOBJS += ../src/crypto/crypto_openssl.o
ifdef NEED_FIPS186_2_PRF
OBJS += ../src/crypto/fips_prf_openssl.o
endif
LIBS += -lcrypto
LIBS_h += -lcrypto
endif

ifeq ($(CONFIG_TLS), gnutls)
ifdef TLS_FUNCS
OBJS += ../src/crypto/tls_gnutls.o
LIBS += -lgnutls -lgpg-error
endif
OBJS += ../src/crypto/crypto_gnutls.o
HOBJS += ../src/crypto/crypto_gnutls.o
ifdef NEED_FIPS186_2_PRF
OBJS += ../src/crypto/fips_prf_gnutls.o
endif
LIBS += -lgcrypt
LIBS_h += -lgcrypt
CONFIG_INTERNAL_SHA256=y
CONFIG_INTERNAL_RC4=y
CONFIG_INTERNAL_DH_GROUP5=y
endif

ifeq ($(CONFIG_TLS), schannel)
ifdef TLS_FUNCS
OBJS += ../src/crypto/tls_schannel.o
endif
OBJS += ../src/crypto/crypto_cryptoapi.o
OBJS_p += ../src/crypto/crypto_cryptoapi.o
CONFIG_INTERNAL_SHA256=y
CONFIG_INTERNAL_RC4=y
CONFIG_INTERNAL_DH_GROUP5=y
endif

ifeq ($(CONFIG_TLS), nss)
ifdef TLS_FUNCS
OBJS += ../src/crypto/tls_nss.o
LIBS += -lssl3
endif
OBJS += ../src/crypto/crypto_nss.o
ifdef NEED_FIPS186_2_PRF
OBJS += ../src/crypto/fips_prf_nss.o
endif
LIBS += -lnss3
LIBS_h += -lnss3
CONFIG_INTERNAL_MD4=y
CONFIG_INTERNAL_DH_GROUP5=y
endif

ifeq ($(CONFIG_TLS), internal)
ifndef CONFIG_CRYPTO
CONFIG_CRYPTO=internal
endif
ifdef TLS_FUNCS
OBJS += ../src/crypto/crypto_internal-rsa.o
OBJS += ../src/crypto/tls_internal.o
OBJS += ../src/tls/tlsv1_common.o
OBJS += ../src/tls/tlsv1_record.o
OBJS += ../src/tls/tlsv1_cred.o
OBJS += ../src/tls/tlsv1_server.o
OBJS += ../src/tls/tlsv1_server_write.o
OBJS += ../src/tls/tlsv1_server_read.o
OBJS += ../src/tls/asn1.o
OBJS += ../src/tls/rsa.o
OBJS += ../src/tls/x509v3.o
OBJS += ../src/tls/pkcs1.o
OBJS += ../src/tls/pkcs5.o
OBJS += ../src/tls/pkcs8.o
NEED_SHA256=y
NEED_BASE64=y
NEED_TLS_PRF=y

=== src/crypto/Makefile ===
all: libcrypto.a

clean:
	rm -f *~ *.o *.d *.gcno *.gcda *.gcov libcrypto.a

install:
	@echo Nothing to be made.


include ../lib.rules

CFLAGS += -DCONFIG_TLS_INTERNAL_CLIENT
CFLAGS += -DCONFIG_TLS_INTERNAL_SERVER
#CFLAGS += -DALL_DH_GROUPS
CFLAGS += -DCONFIG_SHA256

LIB_OBJS= \
	aes-cbc.o \
	aes-ccm.o \
	aes-ctr.o \
	aes-eax.o \
	aes-encblock.o \
	aes-gcm.o \
	aes-internal.o \
	aes-internal-dec.o \
	aes-internal-enc.o \
	aes-omac1.o \
	aes-unwrap.o \
	aes-wrap.o \
	des-internal.o \
	dh_group5.o \
	dh_groups.o \
	md4-internal.o \
	md5.o \
	md5-internal.o \
	milenage.o \
	ms_funcs.o \
	rc4.o \
	sha1.o \
	sha1-internal.o \
	sha1-pbkdf2.o \
	sha1-prf.o \
	sha1-tlsprf.o \
	sha1-tprf.o \
	sha256.o \
	sha256-prf.o \
	sha256-tlsprf.o \
	sha256-internal.o

LIB_OBJS += crypto_internal.o
LIB_OBJS += crypto_internal-cipher.o
LIB_OBJS += crypto_internal-modexp.o
LIB_OBJS += crypto_internal-rsa.o
LIB_OBJS += tls_internal.o
LIB_OBJS += fips_prf_internal.o
LIB_OBJS += random.o


libcrypto.a: $(LIB_OBJS)
	$(AR) crT $@ $?

-include $(OBJS:%.o=%.d)

=== debian/changelog ===
wpa (2.1-0ubuntu1.7+esm5) trusty-security; urgency=medium

  * SECURITY UPDATE: loading arbitrary shared objects, privilege escalation
    - debian/patches/lib_engine_trusted_path.patch: Allow shared objects
      to only be loaded from /usr/lib, thanks to mdeslaur
    - CVE-2024-5290 

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Tue, 06 Aug 2024 10:32:31 +0530

wpa (2.1-0ubuntu1.7+esm4) trusty-security; urgency=medium

  [ Marc Deslauriers ]
  * SECURITY UPDATE: DoS and possible code execution via P2P provision
    discovery requests
    - debian/patches/CVE-2021-27803-pre1.patch: cleanup handling of unknown
      peer in PD Request processing in src/p2p/p2p_pd.c.
    - debian/patches/CVE-2021-27803.patch: fix a corner case in peer
      addition based on PD Request in src/p2p/p2p_pd.c.
    - CVE-2021-27803

 -- Avital Ostromich <avital.ostromich@canonical.com>  Tue, 02 Mar 2021 15:46:05 -0500

wpa (2.1-0ubuntu1.7+esm3) trusty-security; urgency=medium

  * SECURITY UPDATE: P2P discovery heap overflow
    - debian/patches/CVE-2021-0326.patch: P2P: Fix copying of secondary
      device types for P2P group client
    - CVE-2021-0326
  * SECURITY UPDATE: UPnP SUBSCRIBE misbehavior in WPS AP
    - debian/patches/CVE-2020-12695-1.patch: WPS UPnP: Do not allow
      event subscriptions with URLs to other networks
    - debian/patches/CVE-2020-12695-2.patch: WPS UPnP: Fix event message
      generation using a long URL path
    - debian/patches/CVE-2020-12695-3.patch: WPS UPnP: Handle HTTP
      initiation failures for events more properly
    - CVE-2020-12695

 -- Steve Beattie <sbeattie@ubuntu.com>  Fri, 12 Feb 2021 10:12:23 -0800

wpa (2.1-0ubuntu1.7+esm2) trusty-security; urgency=medium

   * SECURITY UPDATE: Incorrect indication of disconnection in certain
     situations
     - debian/patches/CVE-2019-16275.patch: silently ignore management
       frame from unexpected source address in src/ap/drv_callbacks.c,
       src/ap/ieee882_11.c.
     - CVE-2019-16275

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Tue, 17 Sep 2019 06:23:28 -0300

wpa (2.1-0ubuntu1.7+esm1) trusty-security; urgency=medium

   [ Marc Deslauriers ]
   * SECURITY UPDATE: EAP-pwd DoS via unexpected fragment
    - debian/patches/CVE-2019-11555-1.patch: fix reassembly buffer handling
      in src/eap_server/eap_server_pwd.c.
    - debian/patches/CVE-2019-11555-2.patch: fix reassembly buffer handling
      in src/eap_peer/eap_pwd.c.
    - CVE-2019-11555

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Tue, 07 May 2019 11:06:36 -0300

wpa (2.1-0ubuntu1.7) trusty-security; urgency=medium

  * SECURITY UPDATE: Multiple security issues
    - debian/patches/VU-871675/*.patch: backported upstream patches.
    - CVE-2019-9495
    - CVE-2019-9497
    - CVE-2019-9498
    - CVE-2019-9499
  * SECURITY UPDATE: insecure os_random() fallback
    - debian/patches/CVE-2016-10743.patch: Use only os_get_random() for PIN
      generation.
    - CVE-2016-10743

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 09 Apr 2019 08:28:53 -0400

wpa (2.1-0ubuntu1.6) trusty-security; urgency=medium

  * SECURITY UPDATE: Expose sensitive information
    - debian/patches/CVE-2018-14526.patch: fix in src/rsn_supp/wpa.c.
    - CVE-2018-14526

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Thu, 09 Aug 2018 14:17:41 -0300

wpa (2.1-0ubuntu1.5) trusty-security; urgency=medium

  * SECURITY UPDATE: Multiple issues in WPA protocol
    - debian/patches/2017-1/*.patch: Add patches from Debian jessie
    - CVE-2017-13077, CVE-2017-13078, CVE-2017-13079, CVE-2017-13080,
      CVE-2017-13081, CVE-2017-13082, CVE-2017-13086, CVE-2017-13087,
      CVE-2017-13088
  * SECURITY UPDATE: Denial of service issues
    - debian/patches/2016-1/*.patch: Add patches from Debian jessie
    - CVE-2016-4476
    - CVE-2016-4477

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 16 Oct 2017 08:20:18 -0400

wpa (2.1-0ubuntu1.4) trusty-security; urgency=medium

  * SECURITY UPDATE: unauthorized WNM Sleep Mode GTK control
    - debian/patches/CVE-2015-5310.patch: Ignore Key Data in WNM Sleep Mode
      Response frame if no PMF in use in wpa_supplicant/wnm_sta.c.
    - CVE-2015-5310
  * SECURITY UPDATE: EAP-pwd missing last fragment length validation
    - debian/patches/CVE-2015-5315-1.patch: Fix last fragment length
      validation in src/eap_peer/eap_pwd.c.
    - debian/patches/CVE-2015-5315-2.patch: Fix last fragment length
      validation in src/eap_server/eap_server_pwd.c.
    - CVE-2015-5315

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 09 Nov 2015 07:23:28 -0600

wpa (2.1-0ubuntu1.3) trusty-security; urgency=medium

  * SECURITY UPDATE: denial of service via WPS UPnP
    - debian/patches/CVE-2015-4141.patch: check chunk size in
      src/wps/httpread.c.
    - CVE-2015-4141
  * SECURITY UPDATE: denial of service via AP mode WMM Action frame
    - debian/patches/CVE-2015-4142.patch: check length in src/ap/wmm.c.
    - CVE-2015-4142
  * SECURITY UPDATE: denial of service via EAP-pwd
    - debian/patches/CVE-2015-4143-4146.patch: check lengths in
      src/eap_peer/eap_pwd.c, src/eap_server/eap_server_pwd.c.
    - CVE-2015-4143
    - CVE-2015-4144
    - CVE-2015-4145
    - CVE-2015-4146

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 15 Jun 2015 10:34:37 -0400

wpa (2.1-0ubuntu1.2) trusty-security; urgency=medium

  * SECURITY UPDATE: memcpy overflow in P2P functionality
    - debian/patches/CVE-2015-1863.patch: validate SID element length in
      src/p2p/p2p.c.
    - CVE-2015-1863

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 20 Apr 2015 13:45:07 -0400

wpa (2.1-0ubuntu1.1) trusty-security; urgency=medium

  * SECURITY UPDATE: arbitrary command execution via unsanitized string
    passed to action scripts by wpa_cli and hostapd_cli
    - debian/patches/CVE-2014-3686.patch: added os_exec() helper to
      src/utils/os.h, src/utils/os_unix.c, src/utils/os_win32.c,


=== debian/control ===
Source: wpa
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian/Ubuntu wpasupplicant Maintainers <pkg-wpa-devel@lists.alioth.debian.org>
Uploaders: Kel Modderman <kel@otaku42.de>,
 Stefan Lippers-Hollmann <s.l-h@gmx.de>,
 Jan Dittberner <jandd@debian.org>
Build-Depends: debhelper (>> 9.20120115),
 libdbus-glib-1-dev,
 libssl-dev,
 libqt4-dev,
 libdbus-1-dev,
 libncurses5-dev,
 libpcsclite-dev,
 libnl-3-dev (>= 3.2.3-2~) [linux-any],
 libnl-genl-3-dev (>= 3.2.3-2~) [linux-any],
 libpcap-dev [kfreebsd-any],
 libbsd-dev [kfreebsd-any],
 libreadline-gplv2-dev,
 pkg-config,
 qt4-qmake,
 docbook-to-man,
 docbook-utils
Build-Conflicts: libqt3-dev
Standards-Version: 3.9.3
Vcs-Svn: svn://anonscm.debian.org/svn/pkg-wpa/wpa/trunk/
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-wpa/wpa/trunk/
Homepage: http://w1.fi/wpa_supplicant/

Package: hostapd
Architecture: linux-any kfreebsd-any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base (>= 3.2-13), initscripts (>= 2.88dsf-13.3)
Description: user space IEEE 802.11 AP and IEEE 802.1X/WPA/WPA2/EAP Authenticator
 Originally, hostapd was an optional user space component for Host AP
 driver. It adds more features to the basic IEEE 802.11 management
 included in the kernel driver: using external RADIUS authentication
 server for MAC address based access control, IEEE 802.1X Authenticator
 and dynamic WEP keying, RADIUS accounting, WPA/WPA2 (IEEE 802.11i/RSN)
 Authenticator and dynamic TKIP/CCMP keying.
 .
 The current version includes support for other drivers, an integrated
 EAP authenticator (i.e., allow full authentication without requiring
 an external RADIUS authentication server), and RADIUS authentication
 server for EAP authentication.
 .
 hostapd works with the following drivers:
 .
  * mac80211 based drivers with support for master mode [linux]
  * Host AP driver for Prism2/2.5/3 [linux]
  * Driver interface for FreeBSD net80211 layer [kfreebsd]
  * Any wired Ethernet driver for wired IEEE 802.1X authentication.

Package: wpagui
Architecture: linux-any kfreebsd-any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, wpasupplicant (>= 0.7.3~), libqt4-svg
Recommends: menu
Description: graphical user interface for wpa_supplicant
 wpagui provides a Qt interface for choosing which configured network
 to connect to. It also provides a method for browsing 802.11 SSID scan
 results, an event history log of messages generated by wpa_supplicant,
 and a method to add or edit wpa_supplicant networks.

Package: wpasupplicant
Architecture: linux-any kfreebsd-any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base (>= 3.0-6), adduser, initscripts (>= 2.88dsf-13.3)
Suggests: wpagui, libengine-pkcs11-openssl
Description: client support for WPA and WPA2 (IEEE 802.11i)
 WPA and WPA2 are methods for securing wireless networks, the former
 using IEEE 802.1X, and the latter using IEEE 802.11i. This software
 provides key negotiation with the WPA Authenticator, and controls
 association with IEEE 802.11i networks.

Package: wpasupplicant-udeb
Section: debian-installer
Priority: standard
Architecture: linux-any
Package-Type: udeb
Depends: ${shlibs:Depends}, ${misc:Depends}, busybox-udeb
Description: Client support for WPA and WPA2 (IEEE 802.11i)
 WPA and WPA2 are methods for securing wireless networks, the former
 using IEEE 802.1X, and the latter using IEEE 802.11i. This software
 provides key negotiation with the WPA Authenticator, and controls
 association with IEEE 802.11i networks.
 .
 This is a udeb of wpasupplicant for use by the debian-installer.

=== debian/rules ===
#!/usr/bin/make -f

# The build system doesn't use CPPFLAGS, pass them to CFLAGS/CXXFLAGS to
# enable the missing (hardening) flags
CFLAGS   += -MMD -Wall $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

UCFLAGS  = -MMD -Wall -g -Os

BINDIR   = /sbin
V = 1

DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	CC=$(DEB_HOST_GNU_TYPE)-gcc
endif

export CC BINDIR V

DEB_HOST_ARCH_OS              ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
HOSTAPD_DOT_CONFIG            := debian/config/hostapd/$(DEB_HOST_ARCH_OS)
WPASUPPLICANT_DOT_CONFIG      := debian/config/wpasupplicant/$(DEB_HOST_ARCH_OS)
WPASUPPLICANT_UDEB_DOT_CONFIG := debian/config/wpasupplicant/$(DEB_HOST_ARCH_OS)-udeb
VERSION                       := $(shell dpkg-parsechangelog | sed -ne 's,^Version: *\([0-9]*:\)\?\(.*\)$$,\2,p')

### start dh overrides
override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=wpa_supplicant/wpa_gui-qt4 \
	                  --buildsystem=qmake

override_dh_auto_build:
	# build documentation
	dh_auto_build --sourcedirectory=wpa_supplicant/doc/docbook \
	              --buildsystem=makefile \
		      --parallel \
		      -- man
	# build wpasupplicant-udeb
	cp -v --remove-destination $(WPASUPPLICANT_UDEB_DOT_CONFIG) wpa_supplicant/.config
	CFLAGS="$(UCFLAGS)" dh_auto_build --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile \
		      --parallel
	mv -v wpa_supplicant/wpa_supplicant wpa_supplicant/wpa_supplicant-udeb
	dh_auto_clean --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile
	# build wpasupplicant
	cp -v --remove-destination $(WPASUPPLICANT_DOT_CONFIG) wpa_supplicant/.config
	dh_auto_build --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile \
		      --parallel
	# build wpa_gui-qt4
	dh_auto_build --sourcedirectory=wpa_supplicant/wpa_gui-qt4 \
	              --buildsystem=qmake \
		      --parallel
	dh_auto_clean --sourcedirectory=src --buildsystem=makefile
	# build hostapd
	cp -v --remove-destination $(HOSTAPD_DOT_CONFIG) hostapd/.config
	dh_auto_build --sourcedirectory=hostapd \
	              --buildsystem=makefile \
		      --parallel
	dh_auto_clean --sourcedirectory=src --buildsystem=makefile

override_dh_auto_clean:
	dh_auto_clean --sourcedirectory=wpa_supplicant/doc/docbook \
	              --buildsystem=makefile
	dh_auto_clean --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile
	dh_auto_clean --sourcedirectory=wpa_supplicant/wpa_gui-qt4 \
	              --buildsystem=qmake
	-find wpa_supplicant/wpa_gui-qt4 -type d \
		-name \.moc -o -name \.ui -o -name \.obj -exec rm -rf {} \;
	dh_auto_clean --sourcedirectory=hostapd \
	              --buildsystem=makefile

override_dh_auto_install:
	$(info Skip dh_auto_install ...)

override_dh_clean:
	# make sure to remove the staging directory for the udeb
	rm -rf debian/wpasupplicant-udeb
	dh_clean wpa_supplicant/.config \
		 hostapd/.config \
		 wpa_supplicant/wpa_supplicant-udeb

override_dh_install:
	dh_install
	# install systemd support
	install --mode=644 -D wpa_supplicant/systemd/wpa_supplicant.service \
		debian/wpasupplicant/lib/systemd/system/wpa_supplicant.service
	# install D-Bus service activation files & configuration
	install --mode=644 -D wpa_supplicant/dbus/dbus-wpa_supplicant.conf \
		debian/wpasupplicant/etc/dbus-1/system.d/wpa_supplicant.conf
	install --mode=644 -D wpa_supplicant/dbus/fi.epitest.hostap.WPASupplicant.service \
		debian/wpasupplicant/usr/share/dbus-1/system-services/fi.epitest.hostap.WPASupplicant.service
	install --mode=644 -D wpa_supplicant/dbus/fi.w1.wpa_supplicant1.service \
		debian/wpasupplicant/usr/share/dbus-1/system-services/fi.w1.wpa_supplicant1.service
	install --mode=755 -D wpa_supplicant/examples/60_wpa_supplicant \
		debian/wpasupplicant/usr/lib/pm-utils/sleep.d/60_wpa_supplicant
	# install ifupdown hook scripts
	install --mode=755 -D debian/ifupdown/action_wpa.sh \
		debian/wpasupplicant/etc/wpa_supplicant/action_wpa.sh
	install --mode=755 -D debian/ifupdown/functions.sh \
		debian/wpasupplicant/etc/wpa_supplicant/functions.sh
	install --mode=755 -D debian/ifupdown/wpasupplicant.sh \
		debian/wpasupplicant/etc/wpa_supplicant/ifupdown.sh
	install --mode=755 -D debian/ifupdown/hostapd.sh \
		debian/hostapd/etc/hostapd/ifupdown.sh
	# Install udeb
	install --mode=755 -D wpa_supplicant/wpa_supplicant-udeb \
		debian/wpasupplicant-udeb/sbin/wpa_supplicant

override_dh_installchangelogs:
	dh_installchangelogs --package=hostapd hostapd/ChangeLog
	dh_installchangelogs --package=wpasupplicant wpa_supplicant/ChangeLog
	dh_installchangelogs --package=wpagui wpa_supplicant/ChangeLog

override_dh_gencontrol:
	dh_gencontrol -phostapd -- '-v1:$(VERSION)'
	dh_gencontrol --remaining-packages
### end dh overrides

%:
	dh $@

get-orig-source:
	chmod +x $(CURDIR)/debian/get-orig-source
	$(CURDIR)/debian/get-orig-source $(CURDIR)

## wpa 2.3

=== debian/changelog ===
wpa (2.3-1+deb8u5) jessie-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Add patches to fix WPA protocol vulnerabilities (CVE-2017-13077,
    CVE-2017-13078, CVE-2017-13079, CVE-2017-13080, CVE-2017-13081,
    CVE-2017-13082, CVE-2017-13086, CVE-2017-13087, CVE-2017-13088):
    - hostapd: Avoid key reinstallation in FT handshake
    - Prevent reinstallation of an already in-use group key
    - Extend protection of GTK/IGTK reinstallation of WNM-Sleep Mode cases
    - Fix PTK rekeying to generate a new ANonce
    - TDLS: Reject TPK-TK reconfiguration
    - WNM: Ignore WNM-Sleep Mode Response if WNM-Sleep Mode has not been used
    - WNM: Ignore WNM-Sleep Mode Response without pending request
    - FT: Do not allow multiple Reassociation Response frames
    - TDLS: Ignore incoming TDLS Setup Response retries

 -- Yves-Alexis Perez <corsac@debian.org>  Sat, 14 Oct 2017 14:11:26 +0200

wpa (2.3-1+deb8u4) jessie; urgency=medium

  * Non-maintainer upload.
  * Add patches to address CVE-2016-4476 and CVE-2016-4477, thanks to
    Salvatore Bonaccorso <carnil@debian.org> (Closes: #823411):
    - WPS: Reject a Credential with invalid passphrase
    - Reject psk parameter set with invalid passphrase character
    - Remove newlines from wpa_supplicant config network output
    - Reject SET_CRED commands with newline characters in the string values
    - Reject SET commands with newline characters in the string values
  * Refresh patches to apply cleanly.

 -- Andrew Shadura <andrewsh@debian.org>  Thu, 21 Jul 2016 09:01:51 +0200

wpa (2.3-1+deb8u3) jessie-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Add CVE-2015-5314.patch patch.
    CVE-2015-5314: hostapd: EAP-pwd missing last fragment length validation.
  * Add CVE-2015-5315.patch patch.
    CVE-2015-5315: wpa_supplicant: EAP-pwd missing last fragment length
    validation.
  * Add CVE-2015-5316.patch patch.
    CVE-2015-5316: EAP-pwd peer error path failure on unexpected Confirm
    message.

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 07 Nov 2015 16:05:23 +0100

wpa (2.3-1+deb8u2) jessie-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Add patch to address CVE-2015-4141.
    CVE-2015-4141: WPS UPnP vulnerability with HTTP chunked transfer
    encoding. (Closes: #787372)
  * Add patch to address CVE-2015-4142.
    CVE-2015-4142: Integer underflow in AP mode WMM Action frame processing.
    (Closes: #787373)
  * Add patches to address CVE-2015-414{3,4,5,6}
    CVE-2015-4143 CVE-2015-4144 CVE-2015-4145 CVE-2015-4146: EAP-pwd missing
    payload length validation. (Closes: #787371)
  * Add patch to address 2015-5 vulnerability.
    NFC: Fix payload length validation in NDEF record parser (Closes: #795740)
  * Add patch to address CVE-2015-5310.
    CVE-2015-5310: wpa_supplicant unauthorized WNM Sleep Mode GTK control.

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 31 Oct 2015 10:07:44 +0100

wpa (2.3-1+deb8u1) jessie-security; urgency=high

  * import "P2P: Validate SSID element length before copying it
    (CVE-2015-1863)" from upstream (Closes: #783148).

 -- Stefan Lippers-Hollmann <s.l-h@gmx.de>  Thu, 23 Apr 2015 19:32:29 +0200

wpa (2.3-1) unstable; urgency=medium

  * New upstream release:
    - fixed by the new upstream version:
      + wpa: arbitrary command execution via action scripts (Closes: #765352).
        wpasupplicant: fixed wpa_cli action script execution to use more
        robust mechanism (CVE-2014-3686).
        hostapd: fixed hostapd_cli action script execution to use more robust
        mechanism (CVE-2014-3686).
      + wpasupplicant: MAC addressing changing broken after updating to 2.2-1
        (Closes: #763775).
      + drop ap_config_c_fix-typo-for-capabilities, applied upstream.
    - backport "Include ieee802_11_common.c in wpa_supplicant build
      unconditionally" from HEAD, to fix a newly introduced FTBS on, at least,
      kfreebsd.
  * bump standards version to 3.9.6, no changes necessary.

 -- Stefan Lippers-Hollmann <s.l-h@gmx.de>  Tue, 14 Oct 2014 21:29:37 +0200

wpa (2.2-1) unstable; urgency=medium

  * New upstream release:
    - import suggested changes from Gerald Turner <gturner@unzane.com> (see
      #718651 for details).
      + disable ACS for hostapd on kfreebsd-any (FTBS).
    - fixed by the new upstream version:
      + wpa_supplicant: OpenSSL: tls_connection_handshake - Failed to read
      (Closes: #561081).
      + wpasupplicant: new upstream release 2.2 (Closes: #718651).
      + wpasupplicant: -s option not documented in man page (Closes: #608135).
    - refresh patches:
      + drop 13_human_readable_signal.patch, applied upstream.
      + drop hostapd_fix-WDS-VLAN-bridge-handling.patch, applied upstream.
      + drop fix-spelling-s-algorith-algorithm.patch, applied upstream.
    - adapt build configs for hostapd/ wpa_supplicant 2.2:
      + sync with updated upstream defconfigs.
      + keep Hotspot 2.0 support disabled for the time being.
      + hostapd: keep sqlite3 support disabled for the time being.
    - update debian/copyright manually, the wpa v2 branch was relicensed from
      (BSD-3-clause || GPL-2) to BSD-3-clause only (for the most part). This
      doesn't change the licensing state as the BSD-3-clause license is 
      compatible with GPL-2.
  * drop pre-wheezy /lib/init/rw/sendsigs.omit.d/ migration support, invert the
    versioned initscripts dependency to a versioned breaks relation.
  * migrate from /var/run/ to /run/.
  * adapt get-orig-source for wpa 2.2.
  * drop version qualifiers for libnl3 build dependencies, as they're
    fullfilled by wheezy.
  * drop version qualifiers for the lsb-base build dependency, as they're
    fullfilled by squeeze.
  * shorten short description for hostapd.
  * sort debian/control entries.
  * make lintian happy (invalid-short-name-in-dep5-copyright bsd) and call it
    BSD-3-clause.


=== debian/control ===
--- 
+++ 
@@ -1,38 +1,39 @@
 Source: wpa
-Section: net
-Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian/Ubuntu wpasupplicant Maintainers <pkg-wpa-devel@lists.alioth.debian.org>
+Maintainer: Debian wpasupplicant Maintainers <pkg-wpa-devel@lists.alioth.debian.org>
 Uploaders: Kel Modderman <kel@otaku42.de>,
  Stefan Lippers-Hollmann <s.l-h@gmx.de>,
  Jan Dittberner <jandd@debian.org>
+Section: net
+Priority: optional
 Build-Depends: debhelper (>> 9.20120115),
- libdbus-glib-1-dev,
+ libdbus-1-dev,
  libssl-dev,
  libqt4-dev,
- libdbus-1-dev,
  libncurses5-dev,
  libpcsclite-dev,
- libnl-3-dev (>= 3.2.3-2~) [linux-any],
- libnl-genl-3-dev (>= 3.2.3-2~) [linux-any],
+ libnl-3-dev [linux-any],
+ libnl-genl-3-dev [linux-any],
+ libnl-route-3-dev [linux-any],
  libpcap-dev [kfreebsd-any],
  libbsd-dev [kfreebsd-any],
- libreadline-gplv2-dev,
+ libreadline-dev,
  pkg-config,
  qt4-qmake,
  docbook-to-man,
  docbook-utils
-Build-Conflicts: libqt3-dev
-Standards-Version: 3.9.3
-Vcs-Svn: svn://anonscm.debian.org/svn/pkg-wpa/wpa/trunk/
+Standards-Version: 3.9.6
 Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-wpa/wpa/trunk/
+Vcs-Svn: svn://anonscm.debian.org/pkg-wpa/wpa/trunk/
 Homepage: http://w1.fi/wpa_supplicant/
 
 Package: hostapd
 Architecture: linux-any kfreebsd-any
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base (>= 3.2-13), initscripts (>= 2.88dsf-13.3)
-Description: user space IEEE 802.11 AP and IEEE 802.1X/WPA/WPA2/EAP Authenticator
+Depends: ${shlibs:Depends},
+ ${misc:Depends},
+ lsb-base
+Breaks: initscripts (<< 2.88dsf-13.3)
+Description: IEEE 802.11 AP and IEEE 802.1X/WPA/WPA2/EAP Authenticator
  Originally, hostapd was an optional user space component for Host AP
  driver. It adds more features to the basic IEEE 802.11 management
  included in the kernel driver: using external RADIUS authentication
@@ -55,7 +56,10 @@
 Package: wpagui
 Architecture: linux-any kfreebsd-any
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}, wpasupplicant (>= 0.7.3~), libqt4-svg
+Depends: ${shlibs:Depends},
+ ${misc:Depends},
+ wpasupplicant (>= 0.7.3~),
+ libqt4-svg
 Recommends: menu
 Description: graphical user interface for wpa_supplicant
  wpagui provides a Qt interface for choosing which configured network
@@ -66,8 +70,13 @@
 Package: wpasupplicant
 Architecture: linux-any kfreebsd-any
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base (>= 3.0-6), adduser, initscripts (>= 2.88dsf-13.3)
-Suggests: wpagui, libengine-pkcs11-openssl
+Depends: ${shlibs:Depends},
+ ${misc:Depends},
+ lsb-base,
+ adduser
+Suggests: wpagui,
+ libengine-pkcs11-openssl
+Breaks: initscripts (<< 2.88dsf-13.3)
 Description: client support for WPA and WPA2 (IEEE 802.11i)
  WPA and WPA2 are methods for securing wireless networks, the former
  using IEEE 802.1X, and the latter using IEEE 802.11i. This software
@@ -75,11 +84,13 @@
  association with IEEE 802.11i networks.
 
 Package: wpasupplicant-udeb
+Architecture: linux-any
 Section: debian-installer
 Priority: standard
-Architecture: linux-any
+Depends: ${shlibs:Depends},
+ ${misc:Depends},
+ busybox-udeb
 Package-Type: udeb
-Depends: ${shlibs:Depends}, ${misc:Depends}, busybox-udeb
 Description: Client support for WPA and WPA2 (IEEE 802.11i)
  WPA and WPA2 are methods for securing wireless networks, the former
  using IEEE 802.1X, and the latter using IEEE 802.11i. This software

=== debian/rules ===
--- 
+++ 
@@ -1,13 +1,18 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+include /usr/share/dpkg/buildflags.mk
 
 # The build system doesn't use CPPFLAGS, pass them to CFLAGS/CXXFLAGS to
 # enable the missing (hardening) flags
-CFLAGS   += -MMD -Wall $(CPPFLAGS)
-CXXFLAGS += $(CPPFLAGS)
+DEB_CFLAGS_MAINT_APPEND   = -MMD -Wall $(shell dpkg-buildflags --get CPPFLAGS)
+DEB_CXXFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)
+DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed
+export DEB_CFLAGS_MAINT_APPEND DEB_CXXFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND
 
-UCFLAGS  = -MMD -Wall -g -Os
+UCFLAGS   = -MMD -Wall -g -Os -fPIC
 
-BINDIR   = /sbin
+BINDIR    = /sbin
 V = 1
 
 DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
@@ -117,12 +122,14 @@
 override_dh_gencontrol:
 	dh_gencontrol -phostapd -- '-v1:$(VERSION)'
 	dh_gencontrol --remaining-packages
+
+override_dh_builddeb:
+	dh_builddeb -- -Zxz -z6
 ### end dh overrides
 
 %:
-	dh $@
+	dh ${@} --parallel
 
 get-orig-source:
 	chmod +x $(CURDIR)/debian/get-orig-source
 	$(CURDIR)/debian/get-orig-source $(CURDIR)
-
